<?php

/**
 * @package     Joomla.Plugin
 * @subpackage  System.leadinfo
 *
 * @copyright   Copyright 2018
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 * @license     https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 */

// no direct access
defined( '_JEXEC' ) or die;
use Joomla\CMS\Factory;

class plgSystemLeadinfo extends JPlugin
{
    /**
     * Load the language file on instantiation. Note this is only available in Joomla 3.1 and higher.
     * If you want to support 3.0 series you must override the constructor
     *
     * @var    boolean
     * @since  3.1
     */

    /**
     * Plugin method with the same name as the e vent will be called automatically.
     */

    public function onAfterRender()
    {
        $app = JFactory::getApplication();

        if (!$app->isClient('administrator')) {
            if ($this->params->get('trackercode', false)) {

                $LI = $this->params->get('trackercode');
                $this->injectLiCode($LI);
            }
        }
    }

    public function injectLiCode($LI)
    {
        $app = JFactory::getApplication();
        // retrieve all the response as an html string
        $html = $app->getBody();
        // replace the closing body tag with your scripts appending to the closing body tag
        $script = '<!-- Leadinfo tracking code --><script>(function(l,e,a,d,i,n,f,o){if(!l[i]){l.GlobalLeadinfoNamespace=l.GlobalLeadinfoNamespace||[]; l.GlobalLeadinfoNamespace.push(i);l[i]=function(){(l[i].q=l[i].q||[]).push(arguments)};l[i].t=l[i].t||n; l[i].q=l[i].q||[];o=e.createElement(a);f=e.getElementsByTagName(a)[0];o.async=1;o.src=d;f.parentNode.insertBefore(o,f);} }(window,document,"script","https://cdn.leadinfo.net/ping.js","leadinfo","'.$LI.'"));</script>';

        $html = str_replace('</body>',$script . '</body>',$html);

        // override the original response
        $app->setBody($html);
    }
}
